import { AsHtml, Concat, TextPiece } from '../words';

const htmlTagCmd =
  (tag: string) =>
  ({}, argv: TextPiece[]): TextPiece => {
    const [, ...words] = argv;
    return (
      words
        .map((word) => ({ html: `<${tag}>${AsHtml(word)}</${tag}>` }))
        .reduce(Concat, null) ?? { html: "" }
    );
  };

export const h1 = htmlTagCmd("h1");
export const para = htmlTagCmd("p");
export const block = htmlTagCmd("blockquote");

export const ALL = {
  h1,
  para,
  block,
};
